//+------------------------------------------------------------------+
//|                                                     OST Tiks.mq4 |
//|                                                 Nikolaj Ostapjuk |
//|                                                 nikost3@inbox.lv |
//+------------------------------------------------------------------+
#property copyright "Nikolaj Ostapjuk"
#property link      "nikost3@inbox.lv"
//+------------------------------------------------------------------+
//|                                                      TikTakWav.mq4 |
//|                                                     Tokman Yuriy |
//|  13  2008                      yuriytokman@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Yuriy Tokman"
#property link      "yuriytokman@gmail.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Lime
#property indicator_color2 Red
extern bool Play = true;
extern int S1 = 6; 
extern int S2 = 20;
extern int S3 = 50;
int inc5  = 5;
int dec5  = -5;
double price=0,d=0;
double price_prev =0;
double d_max =0;
double d_min =0;
double sum1 = 0;
double sum2 = 0;
double sum3 = 0;
int  i = 0;
double         BufU[];
double         BufD[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(2);
   IndicatorShortName("OST Ticks");
   SetIndexStyle(0,DRAW_ARROW,0,1);
   SetIndexStyle(1,DRAW_ARROW,0,1);
   SetIndexArrow(0,115);
   SetIndexArrow(1,115);
   SetIndexBuffer(0,BufU);
   SetIndexBuffer(1,BufD);
   ArrayInitialize(BufD,0.0);//   .      .
   ArrayInitialize(BufU,0.0);
   
   ObjectCreate("sig1",OBJ_LABEL,0,0,0,0,0);
   ObjectCreate("sig12",OBJ_LABEL,0,0,0,0,0);
   ObjectCreate("sig13",OBJ_LABEL,0,0,0,0,0);
 //  ObjectCreate("sig14",OBJ_LABEL,0,0,0,0,0);
 //  ObjectCreate("sig15",OBJ_LABEL,0,0,0,0,0);
   
   ObjectCreate("sig2",OBJ_LABEL,0,0,0,0,0);
   ObjectCreate("sig22",OBJ_LABEL,0,0,0,0,0);
   ObjectCreate("sig23",OBJ_LABEL,0,0,0,0,0);
//   ObjectCreate("sig24",OBJ_LABEL,0,0,0,0,0);
 //  ObjectCreate("sig25",OBJ_LABEL,0,0,0,0,0);
   
   ObjectCreate("sig3",OBJ_LABEL,0,0,0,0,0);
   ObjectCreate("sig32",OBJ_LABEL,0,0,0,0,0);
   
   ObjectCreate("sig4",OBJ_LABEL,0,0,0,0,0);
   ObjectCreate("sig42",OBJ_LABEL,0,0,0,0,0);
   
   ObjectCreate("sig5",OBJ_LABEL,0,0,0,0,0);
   ObjectCreate("sig52",OBJ_LABEL,0,0,0,0,0);
   
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectsDeleteAll ();

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
    price=MathRound(Bid/Point);
 if (price_prev==price) return;
    d=price-price_prev;
   
// if (d_max < d  && d != price)
//    d_max = d;
    
 //if (d_min > d && d != price)
 //   d_min = d;
 
    string name ;
    string nameSum1 = "Summa "+S1+"=";
    string nameSum2 = "Summa "+S2+"=";
    string nameSum3 = "Summa "+S3+"=";
    string par  = DoubleToStr(d,0);
    string max  = DoubleToStr(d_max,0);
    string min  = DoubleToStr(d_min,0);
  
    int D = MathAbs(d); 
    if (D >= S1&&D < S2 ) sum1 += d;
    string Sum1 = DoubleToStr(sum1,0);
    
    if (D == S2&&D < S3 ) sum2 += d;
    string Sum2 = DoubleToStr(sum2,0);
    
    if (D >= S3&&D <10000 ) sum3 += d;
    string Sum3 = DoubleToStr(sum3,0);
    
    
    if     (d>inc5  && d != price )  
    {
     BufU[i] = Open[i] + d*Point;
     name = " = ";
     ObjectSetText("sig1",name,12,"Arial Black",Lime);
     ObjectSetText("sig12",par,12,"Arial Black",Lime);
     
     if ( d > d_max ) d_max = d;
     ObjectSetText("sig13",max,12,"Arial Black",Lime);
   
  //   if ( d >= inc20 && d < inc50 )
  //   ObjectSetText("sig14",par,12,"Arial Black",Lime);
     
 //    if ( d >= inc50 )
 //    ObjectSetText("sig15",par,12,"Arial Black",Lime);
     
     if ( Play == true )
      {
      if      (d> S3){PlaySound("news.wav");}
      else if (d> S2){PlaySound("ok.wav");}
      else if (d> S1){PlaySound("tick.wav");}
      }
     
    }
    else if(d<dec5)  
    {
     BufD[i] = Open[i] + d*Point;
     name = " = ";
     ObjectSetText("sig2",name,12,"Arial Black",Red);
     ObjectSetText("sig22",par,12,"Arial Black",Red);
     
     if ( d < d_min )   d_min = d;
     ObjectSetText("sig23",min,12,"Arial Black",Red);
     
//     if ( d <= dec20 && d < dec50 )
//     ObjectSetText("sig24",par,12,"Arial Black",Red);
     
 //    if ( d <= dec50 )
 //    ObjectSetText("sig25",par,12,"Arial Black",Red);
     if ( Play == true ) 
      {
      if      ( d< -S3){PlaySound("timeout.wav");}
      else if ( d< -S2){PlaySound("alert2.wav");}
      else if ( d < -S1){PlaySound("expert.wav");}
      }
     
    }
    
   ObjectSet("sig1",OBJPROP_XDISTANCE,3);
   ObjectSet("sig12",OBJPROP_XDISTANCE,85);
   ObjectSet("sig13",OBJPROP_XDISTANCE,130);
 //  ObjectSet("sig14",OBJPROP_XDISTANCE,140);
 //  ObjectSet("sig15",OBJPROP_XDISTANCE,170);

   ObjectSet("sig1",OBJPROP_YDISTANCE,30);
   ObjectSet("sig12",OBJPROP_YDISTANCE,30);
   ObjectSet("sig13",OBJPROP_YDISTANCE,30);
 //  ObjectSet("sig14",OBJPROP_YDISTANCE,30);
 //  ObjectSet("sig15",OBJPROP_YDISTANCE,30);
   
   ObjectSet("sig2",OBJPROP_XDISTANCE,3);
   ObjectSet("sig22",OBJPROP_XDISTANCE,85);
   ObjectSet("sig23",OBJPROP_XDISTANCE,130);
 //  ObjectSet("sig24",OBJPROP_XDISTANCE,140);
//   ObjectSet("sig25",OBJPROP_XDISTANCE,170);
 
   ObjectSet("sig2",OBJPROP_YDISTANCE,50);
   ObjectSet("sig22",OBJPROP_YDISTANCE,50);
   ObjectSet("sig23",OBJPROP_YDISTANCE,50);
//   ObjectSet("sig24",OBJPROP_YDISTANCE,50);
//   ObjectSet("sig25",OBJPROP_YDISTANCE,50);
   
   ObjectSet("sig3",OBJPROP_XDISTANCE,3);
   ObjectSet("sig32",OBJPROP_XDISTANCE,110);
   ObjectSet("sig3",OBJPROP_YDISTANCE,70);
   ObjectSet("sig32",OBJPROP_YDISTANCE,70);
   ObjectSetText("sig3",nameSum1,12,"Arial Black",Goldenrod);
   ObjectSetText("sig32",Sum1,12,"Arial Black",Goldenrod);
   
   ObjectSet("sig4",OBJPROP_XDISTANCE,3);
   ObjectSet("sig42",OBJPROP_XDISTANCE,110);
   ObjectSet("sig4",OBJPROP_YDISTANCE,90);
   ObjectSet("sig42",OBJPROP_YDISTANCE,90);
   ObjectSetText("sig4",nameSum2,12,"Arial Black",Goldenrod);
   ObjectSetText("sig42",Sum2,12,"Arial Black",Goldenrod);
   
   ObjectSet("sig5",OBJPROP_XDISTANCE,3);
   ObjectSet("sig52",OBJPROP_XDISTANCE,110);
   ObjectSet("sig5",OBJPROP_YDISTANCE,110);
   ObjectSet("sig52",OBJPROP_YDISTANCE,110);
   ObjectSetText("sig5",nameSum3,12,"Arial Black",Goldenrod);
   ObjectSetText("sig52",Sum3,12,"Arial Black",Goldenrod);
   
   price_prev=price;
                  
//----
   return(0);
  }
//+------------------------------------------------------------------+